1#!/bin/sh
2# probe libc's inet_pton & backtrace it with ping
3
4# Installs a probe on libc's inet_pton function, that will use uprobes,
5# then use 'perf trace' on a ping to localhost asking for just one packet
6# with the a backtrace 3 levels deep, check that it is what we expect.
7# This needs no debuginfo package, all is done using the libc ELF symtab
8# and the CFI info in the binaries.
9
10# SPDX-License-Identifier: GPL-2.0
11# Arnaldo Carvalho de Melo <acme@kernel.org>, 2017
12
13# shellcheck source=lib/probe.sh
14. "$(dirname "$0")/lib/probe.sh"
15# shellcheck source=lib/probe_vfs_getname.sh
16. "$(dirname "$0")/lib/probe_vfs_getname.sh"
17
18libc=$(grep -w libc /proc/self/maps | head -1 | sed -r 's/.*[[:space:]](\/.*)/\1/g')
19nm -Dg $libc 2>/dev/null | grep -F -q inet_pton || exit 254
20
21event_pattern='probe_libc:inet_pton(\_[[:digit:]]+)?'
22
23add_libc_inet_pton_event() {
24
25	event_name=$(perf probe -f -x $libc -a inet_pton 2>&1 | tail -n +2 | head -n -5 | \
26			grep -P -o "$event_pattern(?=[[:space:]]\(on inet_pton in $libc\))")
27
28	if [ $? -ne 0 ] || [ -z "$event_name" ] ; then
29		printf "FAIL: could not add event\n"
30		return 1
31	fi
32}
33
34trace_libc_inet_pton_backtrace() {
35
36	expected=`mktemp -u /tmp/expected.XXX`
37
38	echo "ping[][0-9 \.:]+$event_name: \([[:xdigit:]]+\)" > $expected
39	echo ".*inet_pton\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
40	case "$(uname -m)" in
41	s390x)
42		eventattr='call-graph=dwarf,max-stack=4'
43		echo "(__GI_)?getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
44		echo "main\+0x[[:xdigit:]]+[[:space:]]\(.*/bin/ping.*\)$" >> $expected
45		;;
46	ppc64|ppc64le)
47		eventattr='max-stack=4'
48		# Add gaih_inet to expected backtrace only if it is part of libc.
49		if nm $libc | grep -F -q gaih_inet.; then
50			echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
51		fi
52		echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
53		echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
54		;;
55	*)
56		eventattr='max-stack=3'
57		echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
58		;;
59	esac
60
61	perf_data=`mktemp -u /tmp/perf.data.XXX`
62	perf_script=`mktemp -u /tmp/perf.script.XXX`
63
64	# Check presence of libtraceevent support to run perf record
65	skip_no_probe_record_support "$event_name/$eventattr/"
66	[ $? -eq 2 ] && return 2
67
68	perf record -e $event_name/$eventattr/ -o $perf_data ping -6 -c 1 ::1 > /dev/null 2>&1
69	# check if perf data file got created in above step.
70	if [ ! -e $perf_data ]; then
71		printf "FAIL: perf record failed to create \"%s\" \n" "$perf_data"
72		return 1
73	fi
74	perf script -i $perf_data | tac | grep -m1 ^ping -B9 | tac > $perf_script
75
76	exec 3<$perf_script
77	exec 4<$expected
78	while read line <&3 && read -r pattern <&4; do
79		[ -z "$pattern" ] && break
80		echo $line
81		echo "$line" | grep -E -q "$pattern"
82		if [ $? -ne 0 ] ; then
83			printf "FAIL: expected backtrace entry \"%s\" got \"%s\"\n" "$pattern" "$line"
84			return 1
85		fi
86	done
87
88	# If any statements are executed from this point onwards,
89	# the exit code of the last among these will be reflected
90	# in err below. If the exit code is 0, the test will pass
91	# even if the perf script output does not match.
92}
93
94delete_libc_inet_pton_event() {
95
96	if [ -n "$event_name" ] ; then
97		perf probe -q -d $event_name
98	fi
99}
100
101# Check for IPv6 interface existence
102ip a sh lo | grep -F -q inet6 || exit 2
103
104skip_if_no_perf_probe && \
105add_libc_inet_pton_event && \
106trace_libc_inet_pton_backtrace
107err=$?
108rm -f ${perf_data} ${perf_script} ${expected}
109delete_libc_inet_pton_event
110exit $err
111